/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package zulu.analyser;

import java.io.IOException;
import org.apache.lucene.analysis.TokenFilter;
import org.apache.lucene.analysis.TokenStream;
import org.apache.lucene.analysis.tokenattributes.CharTermAttribute;
import org.apache.lucene.analysis.tokenattributes.KeywordAttribute;

/**
 * Date - 10 Sep 2014
 *
 * @author NkosanaM
 */
public final class ZuluStemFilter extends TokenFilter {

    private final ZuluStemmer stemmer = new ZuluStemmer();
    private final CharTermAttribute termAtt = addAttribute(CharTermAttribute.class);
    private final KeywordAttribute keywordAttr = addAttribute(KeywordAttribute.class);

    public ZuluStemFilter(TokenStream in) {
        super(in);
        //stemmer = new ZuluStemmer();
        //termAtt = (CharTermAttribute) addAttribute(CharTermAttribute.class);
    }

    @Override
    public final boolean incrementToken() throws IOException {

        if (!input.incrementToken()) {
            return false;
        }
        if ((!keywordAttr.isKeyword()) && stemmer.stem(termAtt.buffer(), 0, termAtt.length())) {
            termAtt.copyBuffer(stemmer.getResultBuffer(), 0, stemmer.getResultLength());  
        }
        //if (stemmer.stem(null))
        //To change body of generated methods, choose Tools | Templates.
        return true;
    }
}
