/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package zulu.analyser;

/**
 * Date - 11 Sep 2014
 *
 * @author NkosanaM
 */
public class ZuluStemmer {

    private char[] result;
    private int resultLen;

    public String stem(String word) {
        if (word.length() > 0) {
            word = removePrefix(word);
            word = removeSuffix(word);
        }

        //word = analyzeSuffixEnd(word);
        return word;
    }

    public void resetBuffer() {
        resultLen = 0;
        result = null;
        //result = new char[50];
    }

    public boolean stem(char[] stream, int start, int end) {
        resetBuffer();
        if (end > start) {
            String word = new String(stream, start, end);
            String res = stem(word);
            allocateNewBuffer(res);

            return true;
        }
        return false;
    }

    private void allocateNewBuffer(String word) {
        result = new char[word.length()];
        for (int i = 0; i < word.length(); i++) {
            result[i] = word.charAt(i);
        }
        resultLen = result.length;
    }

    public char[] getResultBuffer() {
        return result;
    }

    public int getResultLength() {
        return resultLen;
    }

    //correct endings
    private String removePrefix(String word) {
        String firstLetter = word.charAt(0) + "";
        switch (firstLetter) {
            case "a":
                word = classA_Prefix(word);
                break;
            case "e":
                word = classE_Prefix(word);
                break;
            case "i":
                word = classI_Prefix(word);
                break;
            case "o":
                word = classO_Prefix(word);
                break;
            case "u":
                word = classU_Prefix(word);
                break;

        }
        return word;
    }

    private String classA_Prefix(String word) {

        //class 2 and class 6
        if (word.startsWith("aba") || word.startsWith("ama")) {
            word = word.substring(3);
            return word;
        }
        return word;
    }

    //prefixes beginning with the vowel e
    private String classE_Prefix(String word) {
        word = word.substring(1);
        return word;
    }

    private String classI_Prefix(String word) {

        if (word.startsWith("imi") || word.startsWith("ili") || word.startsWith("isi") || word.startsWith("izi")) {
            word = word.substring(3);
            return word;
        }
        if (word.startsWith("in")) {
            word = word.substring(2);
            return word;
        }
        if (word.startsWith("izin")) {
            word = word.substring(2);
            return word;
        }
        //base case is noun class 
        return word.substring(1);
    }

    //
    private String classO_Prefix(String word) {
        if (word.startsWith("oku") || word.startsWith("oko")) {
            word = word.substring(3);
            return word;
        }
        //base case is noun class 
        return word.substring(1);
    }

    private String classU_Prefix(String word) {
        if (word.startsWith("ulu") || word.startsWith("umu") || word.startsWith("ubu") || word.startsWith("uku")) {
            word = word.substring(3);
            return word;
        }
        return word.substring(0);
    }

    /*
     * method that removes suffixes 
     */
    private String removeSuffix(String word) {

        //case with -ana suffix 
        try {
            if (word.endsWith("ana")) {
                word = word.substring(0, word.length() - 3);

                //the -wana case which shows a difference in vowels
                if (word.charAt(word.length() - 1) == 'w') {
                    word = word.substring(0, word.length() - 1);
                }
                return analyzeSuffixEnd(word);
            }

            //case with word ending in "azi"
            if (word.endsWith("azi")) {
                word = word.substring(0, word.length() - 3);

                if (word.charAt(word.length() - 1) == 'k') {
                    word = word.substring(0, word.length() - 1);
                }

                return word;
            }

            if (word.endsWith("se")) {
                word = word.substring(0, word.length() - 2);

                if (word.charAt(0) == 'u') {
                    word = word.substring(1);
                }
                return word;
            }
            return word;
        } catch (Exception e) {
            return word;
        }

    }

    //method analyzes the new end after the suffix has been stripped in order to return words to their normal form
    private String analyzeSuffixEnd(String word) {
        if (word.endsWith("j")) {
            word = word.substring(0, word.length() - 1) + "d";
            return word;
        }

        if (word.endsWith("sh")) {
            word = word.substring(0, word.length() - 2) + "ph";
            return word;
        }

        if (word.endsWith("nj")) {
            word = word.substring(0, word.length() - 2) + "m";
            return word;
        }

        if (word.endsWith("tsh")) {
            word = word.substring(0, word.length() - 3) + "t";
            return word;
        }
        if (word.endsWith("ny")) {
            word = word.substring(0, word.length() - 3) + "n";
            return word;
        }

        if (word.endsWith("ntsh")) {
            word = word.substring(0, word.length() - 4) + "mp";
            return word;
        }
        if (word.endsWith("ny")) {
            word = word.substring(0, word.length() - 2) + "mb";
            return word;
        }

        return word;
    }

    /* public static void main(String[] arg) {
     ZuluStemmer stem = new ZuluStemmer();
     String inkomo = "abafana";
     System.out.println(stem.stem(inkomo.toCharArray(),0,inkomo.length()));
     }
     */
}
