/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package zulu.morph;

import java.util.ArrayList;

/**
 * Date - 24 Sep 2014
 *
 * @author NkosanaM
 */
public class PrefixAnalyzer {

    private ArrayList<String> list;

    public PrefixAnalyzer() {
        list = new ArrayList<String>();
    }

    private String getRoot(Token aToken) {

        if (aToken.checkMap("[NStem]")) {
            return aToken.getWord("[NStem]");
        } else if (aToken.checkMap("[VRoot]")) {
            return aToken.getWord("[VRoot]");
        } else {
            return aToken.getWord("[def]");
        }

    }
    /*
     * method that removes suffixes 
     */

    public String classifyPrePrefix(Token aToken) {
        String preprefix = "";
        String word = getRoot(aToken);
        if (word.length() > 0) {
            preprefix = word.charAt(0) + "";
        }
        try {
            if (preprefix.equals("a")) {
                //negative prefix or plural
                list.add(preprefix);
                list.add("NegPre");
                word = word.substring(1); //some condition here
                return standardPrefixPattern(word);
            } else if (preprefix.equals("e")) {
                //LocPrefix
                list.add(preprefix);;
                list.add("[LocPre]");
                if (aToken.getSuffix().equals("ni")) {
                    if (word.charAt(1) == 'l') {
                        list.add(word.substring(0, 3));
                        word = word.substring(3);
                    } else {
                        word = word.substring(1);
                        //return standardPrefixPattern(word);
                    }
                }
            } else if (preprefix.equals("o")) {
                list.add(preprefix);
                if (aToken.getSuffix().equals("ni")) {
                    list.add("[LocPre]");
                    word = word.substring(1);
                } else {
                    list.add("[NPrePre]");
                    word = word.substring(1);
                }
            } else if (preprefix.equals("u") || preprefix.equals("i")) {
                //noun preprefix
                list.add(preprefix);
                list.add("NPrePre");
                word = word.substring(1);
                return standardPrefixPattern(word); //cvc pattern
            } else {
                return standardPrefixPattern(word);
            }
            return standardPrefixPattern(word);
        } catch (StringIndexOutOfBoundsException w) {
            return word;
        }
    }

    /*
     *   PrefixAnalyzer patterns deal with anything after the preprefix
     *
     */
    private String standardPrefixPattern(String word) {

        //possive concord can either be a CVKA*pattern or a CV.* where v = {a} and C = {blwsy}
        //System.out.println("CUrrent state is " + word);
        if (word.matches("^([^aeiou])([aeiou])[yk][auo].*") || word.matches("^([blwsy])([a]).*")) {
            String cha = "";
            if (word.length() > 3) {
                cha = word.charAt(2) + "";
            }

            if (word.length() > 3 && cha.matches("[yk]")) {
                list.add(word.substring(0, 4));
                word = word.substring(4);
            } else {
                list.add(word.substring(0, 2));
                word = word.substring(2);
            }
            list.add("[PossCon]");

        } //subject concord pattenrn 
        else if (word.matches("^([^aeiou])([w]{0,1})([aiu]).*")) {

            if (word.charAt(1) == 'w') {
                list.add(word.substring(0, 3));
                word = word.substring(3);
            } else {
                list.add(word.substring(0, 2));
                word = word.substring(2);
            }
            list.add("[SC]");
        } //copulative - no preprefix is required CV* pattern
        else if (word.matches("^([^aeiou]{2})([aeiou]).*")) {

            list.add(word.substring(0, 3));
            list.add("[CopPre]");
            word = word.substring(3);
            return standardPrefixPattern(word);

        } //object concord - cvc pattern because a preprefix is a must
        else if (word.matches("^([^aeiou])([aiu]).*")) {
            list.add(word.substring(0, 3));
            list.add("[OC]");
            word = word.substring(3);
        } else if (word.matches("^([aeiou]).*")) {
            word = word.substring(1);
        }

        list.add(word);

        return word;
    }

    public String addToToken(Token aToken) {
        String result = classifyPrePrefix(aToken);
        for (int i = list.size() - 2; i >= 1; i -= 2) {
            aToken.addToQueue(list.get(i), list.get(i - 1));
        }
        return result;
    }

}
