/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package zulu.morph;

import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * Date - 11 Sep 2014
 *
 * @author NkosanaM
 */
public class ZuluMorphAnalyzer {

    private char[] result;
    private int resultLen;
    private Token atoken;
    private SuffixAnalyzer sufAnalyzer;
    private PrefixAnalyzer prefAnalyzer;

    //private PrefixAnalyzer

    public ZuluMorphAnalyzer() {

    }

    public String stem(String word) {
        atoken = new Token(word);
        sufAnalyzer = new SuffixAnalyzer();
        prefAnalyzer = new PrefixAnalyzer();
        sufAnalyzer.suffixStem(atoken);
        String res = prefAnalyzer.addToToken(atoken);
        if (res.length() > 0) {
            return res;
        } else {
            return word;
        }
    }

    public void resetBuffer() {
        resultLen = 0;
        result = null;
        //result = new char[50];
    }

    public boolean stem(char[] stream, int start, int end) {
        resetBuffer();
        if (end > start) {
            String word = new String(stream, start, end);
            String res = stem(word);
            allocateNewBuffer(res);
            return true;
        }
        return false;
    }

    private void allocateNewBuffer(String word) {
        result = new char[word.length()];
        for (int i = 0; i < word.length(); i++) {
            result[i] = word.charAt(i);
        }
        resultLen = result.length;
    }

    public char[] getResultBuffer() {
        return result;
    }

    public int getResultLength() {
        return resultLen;
    }

    public static void main(String[] arg) throws FileNotFoundException, IOException {

        ZuluMorphAnalyzer analyze = new ZuluMorphAnalyzer();
        String test = "ngabantu";
        char[] stream = test.toCharArray();
        analyze.stem(stream, 0, stream.length);

        //aToken.printTaggedWord();
    }

}
