/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package zulu.morph;

import java.io.IOException;
import org.apache.lucene.analysis.TokenFilter;
import org.apache.lucene.analysis.TokenStream;
import org.apache.lucene.analysis.tokenattributes.CharTermAttribute;
import org.apache.lucene.analysis.tokenattributes.KeywordAttribute;

/**
 * Date - 06 Oct 2014
 * @author NkosanaM
 */
public class ZuluMorphAnalyzerFilter  extends TokenFilter{
    
    private final ZuluMorphAnalyzer stemmer = new ZuluMorphAnalyzer();
    private final CharTermAttribute termAtt = addAttribute(CharTermAttribute.class);
    private final KeywordAttribute keywordAttr = addAttribute(KeywordAttribute.class);
    public ZuluMorphAnalyzerFilter(TokenStream in){
        super(in);
    }
    @Override
    public boolean incrementToken() throws IOException {
         if (!input.incrementToken()) {
            return false;
        }
        if ((!keywordAttr.isKeyword()) && stemmer.stem(termAtt.buffer(), 0, termAtt.length())) {
            termAtt.copyBuffer(stemmer.getResultBuffer(), 0, stemmer.getResultLength());
        }
        return true;
    }
}
