<?php
	include_once ("../vendor/autoload.php");

	class ExecuteQueries{
		private $query;
		private $client;
		private $rows = 10;
		private $pages;
		private $current = 0;
		private $config = array("endpoint" => array("localhost" => array
    	("host" => "127.0.0.1", "port" => "8983", "path" => "/solr"
    	, "core" => "collection1")));


		//function creates a new Solarium Client 
		private function createNewClient(){
			$this->client = new Solarium\Client($this->config);
			$this->client->setAdapter('Solarium\Core\Client\Adapter\Http');
		}

		//function runs query
		public function runQuery($aQuery, $start_row){
			$this->createNewClient();
			$this->query = $this->client->createSelect();
			$this->query->setQuery('text:' . $aQuery);
			$this->query->setStart($start_row)->setRows(10);
			$resultSet = $this->client->select($this->query);
			$this->current = $resultSet->getNumFound();
			
			if ($resultSet->getNumFound() > 0){
				foreach ($resultSet as $doc){
					echo  '<a color="blue" href = "' . $doc->link[0]  . '"><h4>' .  $doc->title[0] . '</h4></a>';
					echo '<div class = "result_text">' . $doc->content[0] . '</div>';
					echo '<hr>';
				}
				echo 'Total number of results: ' . $this->current  . '</br>';
			}
			else{
				echo "<h3> The search did not return any results! </h2>";
			}
			
			

		}
		public function getNumFound(){
			return $this->current;
		}

		private function setPages($numResults){
			$this->pages = ($numResults/$this->rows) + 1;
			echo 'Total number of pages' . $this->pages ;
		}

		private function setQueryString(){

		}
	}

?>
