<?php
include_once ("../vendor/autoload.php");
    

function queryServer($user_query) {

    // create a client instance
    $config = array("endpoint" => array("localhost" => array
    ("host" => "127.0.0.1", "port" => "8983", "path" => "/solr"
    , "core" => "collection1")));
    $client = new Solarium\Client($config);
    
    //select the adapter - if using the curl
    $client->setAdapter('Solarium\Core\Client\Adapter\Http');
    
    //create a query
    $query = $client->createSelect();
    
    $query->setStart(0)->setRows(5);
    //determing what fields are going to be "searched"
    $query->setQuery('text:' . $user_query);
    $resultSet = $client->select($query);
    echo 'Number of results found: ' . count($resultSet);
    foreach($resultSet as $result){
        echo '</br>' . $result->id;
        echo '</br>' . $result->content[0];
    }
}


//function builds user query to access RESTful translation service
function buildTransQuery($user_query) {

	$base_url = 'http://api.mymemory.translated.net/get?q=';
	$options = '&langpair=en|zu&mt=1&';
	$key = 'key=2985165d42869d852902&de=mlmnko002@myuct.ac.za';

    $b_url = $base_url . $user_query;
    return $b_url . $options . $key;
}

function initTranslation($aQuery){
    $translatedString = "";
    if (str_word_count($aQuery) > 1){
        $words = explode(" ",$aQuery);
        foreach ($words as $word){
            $result =  callTranslateAPI($word);
            if (strlen($result) > 0){
                $translatedString = $translatedString . " " . $result;
            }
            else{
                $translatedString = $translatedString . " " .$word;
            }
            
        } 
    }
    else{
        $translatedString = callTranslateAPI($aQuery);
    }
    return $translatedString;
}

//function executes query via cURL. 
function callTranslateAPI($query) {
    $url = buildTransQuery($query);
    //initialize curl session
    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_FAILONERROR, false);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);

    //proxy settings if necessary 
    curl_setopt($curl, CURLOPT_PROXY, 'proxynet.uct.ac.za');         
	curl_setopt($curl, CURLOPT_PROXYPORT, '8080');
	//curl_setopt($ch, CURLOPT_PROXYUSERPWD, '<user>:<pwd>');
    $curl_response = curl_exec($curl);
    
    //error logging
    if ($curl_response === false) {
        $info = curl_getinfo($curl);
        curl_close($curl);
        die('error occured during curl exec. Additioanl info: ' . var_export($info));
    }
    
    //terminate session
    curl_close($curl);
    
    //extract the translated text
    $array = json_decode($curl_response, true);
    $text = "";
    $matches = $array['matches'];
    for ($i = 0; $i < count($matches); $i = $i + 1) {
        $text =  $matches[$i]['translation'] . " " . $text;
    }
    return $text;


}



?>